library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;

entity AB_cell is
port (
   a, b: in STD_LOGIC_VECTOR (N downto 0);
   oper_a : in std_logic;
   c_ce_b : in std_logic;
   new_a, new_b: out STD_LOGIC_VECTOR (N downto 0)
);
end AB_cell;

architecture rtl2 of AB_cell is
signal sum: std_logic_vector(n-1 downto 0);
attribute lut_map: string;

begin

adder: for i in 0 to n-1 generate
  --attribute lut_map of a_sum: label is "yes";
  begin
  a_sum: sum(i) <= a(i+1) xor (oper_a and b(i+1));
end generate;

new_a <= '0' & sum;
--new_b <= a;
new_b <= a when c_ce_b = '1' else b;


end rtl2;

