library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
entity control_ruta is
port (
	d, p: in std_logic_vector(logN downto 0);
	a_0, b_0, v_0, u_0: in std_logic;
	c_ce_b, c_ce_v, c_ce_p: out std_logic;
	cont_u, cont_d: out std_logic_vector(1 downto 0)
);
end control_ruta;

architecture rtl of control_ruta is
--signal boolean_sum_p: std_logic_vector(logN-1 downto 0);
--signal boolean_sum_d: std_logic_vector(logN-2 downto 0);
constant zero: std_logic_vector(logN downto 0):= (others => '0');
signal p_gt_0, d_equ_0, sign_d, u_plus_v: std_logic;

begin

--boolean_sum_p(0) <= p(0);
--or_gates_p: for i in 1 to logN-1 generate
--  boolean_sum_p(i) <= boolean_sum_p(i-1) or p(i);
--end generate;

--boolean_sum_d(0) <= d(1);
--or_gates_d: for i in 1 to logN-2 generate
--  boolean_sum_d(i) <= boolean_sum_d(i-1) or d(i+1);
--end generate;

--p_gt_0 <= (not(p(logN))) and boolean_sum_p(logN - 1);
--d_equ_0 <= (not(d(logN))) and (not(boolean_sum_d(logN-2))) and (not(d(0)));
d_equ_0 <= '1' when d = zero else '0';
sign_d <= d(logN);
--a_0 <= a(0);	--u_0 <= u(0);
u_plus_v <= u_0 xor v_0;


process(p_gt_0, d_equ_0, sign_d, a_0, u_0, u_plus_v, sign_d, d_equ_0)
begin
--	if p_gt_0 = '0' then
--		c_ce_b <= '0'; c_ce_v <= '0'; c_ce_p <= '0';
--		cont_u <= "00"; cont_d <= "00";
--	else
		if a_0 = '0' then
			c_ce_b <= '0'; c_ce_v <= '0'; --c_ce_d <= '1'; 
			if (sign_d = '1') or (d_equ_0 = '1') then
			  c_ce_p <= '1'; 
			else 
			  c_ce_p <= '0';
			end if;
			if u_0 = '0' then 
			  cont_u <= "00"; 
			else
			  cont_u <= "10"; 
			end if;
			cont_d <= "10"; 
		else
			cont_d(1) <= '1';
			if u_plus_v = '0' then 
			  cont_u <= "01"; 
			else 
			  cont_u <= "11"; 
			end if;
			if (sign_d = '0') then
				c_ce_b <= '0'; c_ce_v <= '0';
				if d_equ_0 = '1' then 
				  c_ce_p <= '1'; 
				else 
				  c_ce_p <= '0'; 
				end if;
				cont_d(0) <= '0';
			else
				c_ce_b <= '1'; c_ce_v <= '1';	c_ce_p <= '0';  
				cont_d(0) <= '1';
			end if;
		end if;
--	end if;
end process;

end rtl;

